package com.idiot.operationbackend.service.facade;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.idiot.operationbackend.entity.AccountFans;
import com.idiot.operationbackend.vo.NumberStatData;

import java.util.List;

/**
 * @author wang xiao
 * @date Created in 19:24 2020/9/10
 */
public interface AccountFansService extends IService<AccountFans> {


    /**
     *  openId和公众号id  查询用户
     * @author wangxiao
     * @date 18:59 2020/9/14
     * @param accountId
     * @param openId
     * @return com.idiot.operationbackend.entity.AccountFans
     */
    AccountFans queryByAccountIdAndOpenId (String accountId,String openId);


    /**
     *  统计粉丝总数目
     * @author wangxiao
     * @date 14:26 2020/9/16
     * @param accountId
     * @return int
     */
    int countFansByAccountId(String accountId);


    /**
     *  查询一段时间内的粉丝
     * @author wangxiao
     * @date 18:39 2020/9/16
     * @param accountId
     * @param startDate
     * @param endDate
     * @return java.util.List<com.idiot.operationbackend.entity.AccountFans>
     */
    List<AccountFans> queryFansByDateAndDate (String accountId,String startDate,String endDate);


    /**
     *  粉丝属性得统计
     * @author wangxiao
     * @date 11:03 2020/9/17
     * @param accountId
     * @param startDate
     * @param endDate
     * @return java.util.List<com.idiot.operationbackend.vo.NumberStatData>
     */
    List<NumberStatData> statByFansProperty (String accountId,String startDate,String endDate);


    /**
     *  粉丝列表
     * @author wangxiao
     * @date 19:18 2020/9/17
     * @param accountId
     * @param sex
     * @param city
     * @param province
     * @param tagId
     * @param label
     * @param startTime
     * @param endTime
     * @param page
     * @param pageSize
     * @return com.baomidou.mybatisplus.extension.plugins.pagination.Page<com.idiot.operationbackend.entity.AccountFans>
     */
    Page<AccountFans> pageFans(String accountId,Integer sex, String city,String province,String tagId,String label,String startTime,String endTime ,int page,int pageSize );

    /**
     *  更新备注
     * @author wangxiao
     * @date 19:42 2020/9/17
     * @param accountId
     * @param openId
     * @param remark
     * @return boolean
     */
    boolean updateFansRemark(String accountId, String openId, String remark);
}
